#ifndef OPTIONS_H_
#define OPTIONS_H_

#include <cereal/cereal.hpp>
#include <string>

struct OptionsStruct
{
  int nthreads;         //!< Number of threads to use
  int iters;            //!< Number of iterations between output
  bool display;         //!< Whether to display
  std::string output;   //!< Output prefix
  std::string imagesDir;//!< Image directory for stuff

  template <class Archive>
  void serialize( Archive & ar )
  {
    ar( CEREAL_NVP(nthreads),
        CEREAL_NVP(iters),
        CEREAL_NVP(display),
        CEREAL_NVP(output),
        CEREAL_NVP(imagesDir ) );
  }
};

#endif // OPTIONS_H_
