function [ diffs ] = boActivationTest( input )


% input is [preEdge.weight, borderOwnershipActivation, currentActivation, inhibitorySum]
weights = input(:, 1);
inAct = input(:, 2);
curAct = input(:, 3);
inhib = input(:,4);
inhib(inhib > 1) = 1;

targetWeight = inAct .* curAct;

% unlearning
% delta = weights - (weights ./ (1 + inhib));
delta = inhib;
nupdate = delta .* targetWeight * 1;

nlocalAccumulatorUpdate = inhib .* curAct;

% learning
inhibModulation = 1 - inhib;

% pupdate = 0.02 * inhibModulation .* (targetWeight - weights) .* targetWeight;
pupdate = 0.25 * inhibModulation .* targetWeight;
plocalAccumulatorUpdate = targetWeight;
pupdate = max(pupdate, 0);

diffs = [pupdate - nupdate, plocalAccumulatorUpdate - nlocalAccumulatorUpdate];

plot3(targetWeight, input(:, 4), diffs(:,1), '.');
xlabel('TargetWeight');
ylabel('Inhib');
end