function [ totals, score, unweightedTotals ] = coolScores( I, display )
%coolScores Computes a score for a map based on deviation from uniform
%distribution

NUM_BINS = 18;

I_hsv = rgb2hsv(I);

totals = zeros(1, NUM_BINS);
unweightedTotals = zeros(1, NUM_BINS);

for i = 1:size(I_hsv, 1)
    for j = 1:size(I_hsv, 2)
        if I_hsv(i, j, 3) > 0
            bin = floor(I_hsv(i, j, 1) * NUM_BINS) + 1;
            totals(bin) = totals(bin) + I_hsv(i, j, 3);
            unweightedTotals(bin) = unweightedTotals(bin) + 1;
        end
    end
end

totals = totals / sum(totals);
unweightedTotals = unweightedTotals / sum(unweightedTotals);
expected = 1 / NUM_BINS;
score = sum(abs(totals - expected));

if( display )
    plot(totals);
    hold on
    plot(unweightedTotals);
    plot(ones(1, NUM_BINS) * expected);
end

end