function [ diffs ] = gActivation( input )


% input is [preEdge.weight, borderOwnershipActivation, currentActivation]
weights = input(:, 1);
boAct = input(:, 2);
curAct = input(:, 3);

% unlearning
unlearningModulation = 1 - boAct;
delta = weights - (weights ./ (1 + unlearningModulation));
nupdate = delta .* unlearningModulation .* curAct * 0.02;

nlocalAccumulatorUpdate = unlearningModulation .* curAct;

% learning
targetWeight = boAct .* curAct;
pupdate = 0.002 * boAct .* (targetWeight - weights) .* targetWeight;
plocalAccumulatorUpdate = targetWeight;

diffs = [pupdate - nupdate, plocalAccumulatorUpdate - nlocalAccumulatorUpdate];
end