function [ vals ] = generateNaturalDistribution()
%generateNaturalDistribution Generates a distribution corresponding to
%   the occurence of orientations in natural scenes.  Distribution is 
%   discretized into 360 degrees and represented as the 'height' of each
%   discretized orientation

inVals = 0:1:359;
vals1 = sind(inVals * 4 + 90) * 1 + 14;
vals2 = normpdf(inVals, 180, 20) * 30;
vals3 = normpdf(inVals, 0, 20) * 30;
vals4 = normpdf(inVals, 360, 20) * 30;
vals = sum([vals1; vals2; vals3; vals4]);
vals = vals(1:180);

plot (inVals(1:180), vals);
ylim([0, 30]);

end
