function [hueImage, I] = makePinwheelMat( raw, filename )
%makePinwheelMat Creates a mat file containing the hue matrix from a raw
% v1 image.

I = coolColors( raw, 4, 20, 20 ); % 4 20 20
fprintf('\n');
I = imgaussfilt(I, 4); % we'll convert back to RGB after getting the hues

% convert to angle representation
h = rgb2hsv(I);
h = squeeze(h(:,:,1));

% crop out borders
CROP_AMOUNT = 25;
hueImage = h(CROP_AMOUNT+1:end-CROP_AMOUNT, CROP_AMOUNT+1:end-CROP_AMOUNT);

save( filename, 'hueImage' );

end

% horz = compressAngleRange( h, false );
% diag = compressAngleRange( h, true );
% 
% horzLines = edge(horz, 'Canny') > 0;
% diagLines = edge(diag, 'Canny') > 0;
% 
% % crop out borders
% CROP_AMOUNT = 25;
% horzLines = horzLines(CROP_AMOUNT+1:end-CROP_AMOUNT, CROP_AMOUNT+1:end-CROP_AMOUNT);
% diagLines = diagLines(CROP_AMOUNT+1:end-CROP_AMOUNT, CROP_AMOUNT+1:end-CROP_AMOUNT);
% 
% pinwheels = horzLines & diagLines;
% 
% components = bwconncomp(p, 8);
% num_pinwheels = components.NumObjects;
% 
% % Spectral analysis
% spec = fftshift(abs(fft2( horzLines + 1i * diagLines )));
% 
% end
% 
% function x = compressAngleRange( I, diag )
% 
% if( diag ) % pi/4, 3pi/4
%     x = (I < pi/4) | (I >= 3*pi/4);
% else % 0, pi/2
%     x = I < pi/2;    
% end
% 
% end