function [] = makeThoughtPlots( directory, prefix1, prefix2 )
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here

global bias_graph_offset;
bias_graph_offset = 0.1;

[A, allScoresA] = GetWeightMatrix(directory, prefix1);
[B, allScoresB] = GetWeightMatrix(directory, prefix2);

% plot weights
figure;
for k = 1:size(A, 3)
    subplot(size(A,3), 1, k);
    
%     plot3([zeros(1,3); A(1,:,k)], [zeros(1,3); A(2,:,k)], [zeros(1,3); A(3,:,k)], ...
%      'LineWidth', 4, 'color', [1, 0, 0, 0.2]);
%     hold on
%     plot3([zeros(1,3); B(1,:,k)], [zeros(1,3); B(2,:,k)], [zeros(1,3); B(3,:,k)], ...
%      'LineWidth', 4, 'color', [0, 0, 1, 0.2]);
    
    patchline([zeros(1,3); A(1,:,k)], [zeros(1,3); A(2,:,k)], [zeros(1,3); A(3,:,k)], ...
        'LineWidth', 2, 'edgealpha', 0.4, 'edgecolor', 'r');
    hold on
    patchline([zeros(1,3); B(1,:,k)], [zeros(1,3); B(2,:,k)], [zeros(1,3); B(3,:,k)], ...
        'LineWidth', 2, 'edgealpha', 0.4, 'edgecolor', 'b');
    
    grid on;
    axis square;
    
    view(135, 30);
    xlim([0, 0.5]);
    ylim([0, 0.5]);
    zlim([0, 0.5]);
    set(gca,'XTickLabel',[])
    set(gca,'YTickLabel',[])
    set(gca,'ZTickLabel',[])
end

figure
bar = plotStatisticalError( allScoresB, allScoresA );
set(bar(1),'FaceColor','b');
set(bar(2),'FaceColor','r');
xy = gca;
if isempty(strfind(prefix1, 'noise')) % if bias
    local_YTick = xy.YTick;
    local_YTickLabel = xy.YTickLabel;
    
    for i = 1:length(local_YTick)
        local_YTickLabel(i) = {sprintf('%.1f', local_YTick(i) - bias_graph_offset)};
    end
    
    local_YTick(end+1) = bias_graph_offset;
    local_YTickLabel(end+1) = {'0'};
        
    [xy.YTick, indices] = sort(local_YTick);
    xy.YTickLabel = local_YTickLabel(indices);
end
end

function [B, allScores] = GetWeightMatrix(directory, prefix)
    global bias_graph_offset;
    counter = 0;
    allScores = [];
%     allA = [];
    
    while 1
        files = dir(strcat(directory, strcat(sprintf('%s_%d_', prefix, counter), '*_FF.txt')));       
        if (isempty(files))
            break;
        end
        
        files = {files(~[files.isdir]).name};

        A = []; % for weights

        for f = 1:numel(files)    
            file = char(files(f));

            path = char(fullfile(directory, file)); 
            D = dlmread(path);
            for i = 1:3
                [~, I] = min(D);
                temp = D(i, :);
                D(i, :) = D(I(i), :);
                D(I(i), :) = temp;
            end

            if ~isempty(A)
                A(:,:,size(A, 3)+1) = D;    
            else
                A = D;
            end
        end

        if isempty(strfind(prefix, 'noise')) % if bias
            A = flip(A, 3);
        end

        scores = zeros(1, size(A,3));
        for i = 1:size(A,3)
            scores(i) = GetScore(A(:, :, i));
        end
        
        if isempty(strfind(prefix, 'noise')) % if bias            
            scores = scores + bias_graph_offset;
            % add small offset so we can see things in the graph
            % we'll adjust labels to match this
        end
                
        if isempty(allScores)
            allScores = scores;
        else
            allScores = [allScores; scores];
        end
        
%         if isempty(allA)
%             allA = A;
%         else
%             allA(:,:,:,end+1) = A;
%         end
        
        % 12
        counter = counter + 1;
%         if counter == 12
%             B = A;
%         end
    end
    B = A;
%     B = mean(allA, 4);
end

function [score] = GetScore(A)
ideal = [0, 1, 1; 1, 0, 1; 1, 1, 0] / 2;
score = 0;
for i = 1:3
    mat = [ideal(i, :); A(i, :)];
    score = score + pdist(mat);
end
end