function [ pValues, pValuesRankSum, Scores1, Scores2, Scores3, Scores4 ] = makeV2BoTestComparisons( base_dir )
%makeV2BoTestComparisons Makes histogram plots comparing the
% polarity scores over all test images for the datasets in question

% Make base directory names
%P0G1  = strcat(base_dir, 'shape_results/output_no_proto/');
%P0G1A  = strcat(base_dir, 'shape_results/grouping_no_fb/');
%P1G1  = strcat(base_dir, 'shape_results/proto/');
%P1G1A = strcat(base_dir, 'shape_results/no_grouping_low_thresh/');
%P1G4  = strcat(base_dir, 'shape_results/proto_4g/');

P0G1  = strcat(base_dir, '80x80_CL_0Proto_1Grp_2Gen/final_output/');
P0G1A  = strcat(base_dir, '80x80_CL_0Proto_1Grp_2Gen/final_output_no_ambiguity/');
P1G1  = strcat(base_dir, '80x80_CL_1Proto_1Grp_2Gen/final_output/');
P1G1A = strcat(base_dir, '80x80_CL_1Proto_1Grp_2Gen/final_output_no_ambiguity2/');
P1G4  = strcat(base_dir, '60x60_CL_1Proto_4Grp_3Gen/final_output/');

% Assemble vector of scores
Scores1 = [getScores(P0G1,1), getScores(P0G1A,1), getScores(P1G1,1), getScores(P1G1A,1), getScores(P1G4,1)];
Scores2 = [getScores(P0G1,2), getScores(P0G1A,2), getScores(P1G1,2), getScores(P1G1A,2), getScores(P1G4,2)];
Scores3 = [getScores(P0G1,3), getScores(P0G1A,3), getScores(P1G1,3), getScores(P1G1A,3), getScores(P1G4,3)];
Scores4 = [getScores(P0G1,4), getScores(P0G1A,4), getScores(P1G1,4), getScores(P1G1A,4), getScores(P1G4,4)];

%filter_amount = 0.8;
%
%filter = Scores3(:,5) > filter_amount;
%
%s31 = Scores3(:,1);
%s32 = Scores3(:,2);
%s33 = Scores3(:,3);
%s34 = Scores3(:,4);
%s35 = Scores3(:,5);
%
%s31 = s31(filter);
%s32 = s32(filter);
%s33 = s33(filter);
%s34 = s34(filter);
%s35 = s35(filter);
%
%Scores3 = [s31, s32, s33, s34, s35];
%
%filter = Scores4(:,5) > filter_amount;
%
%s41 = Scores4(:,1);
%s42 = Scores4(:,2);
%s43 = Scores4(:,3);
%s44 = Scores4(:,4);
%s45 = Scores4(:,5);
%
%s41 = s41(filter);
%s42 = s42(filter);
%s43 = s43(filter);
%s44 = s44(filter);
%s45 = s45(filter);
%
%Scores4 = [s41, s42, s43, s44, s45];

%% Median Analysis
CONF_INTERVAL = 5;

m1 = median(Scores1,1)
l1 = m1 - prctile(Scores1, 50 - CONF_INTERVAL, 1);
u1 = prctile(Scores1, 50 + CONF_INTERVAL, 1) - m1;

m2 = median(Scores2,1)
l2 = m2 - prctile(Scores2, 50 - CONF_INTERVAL, 1);
u2 = prctile(Scores2, 50 + CONF_INTERVAL, 1) - m2;

m3 = median(Scores3,1)
l3 = m3 - prctile(Scores3, 50 - CONF_INTERVAL, 1);
u3 = prctile(Scores3, 50 + CONF_INTERVAL, 1) - m3;

m4 = median(Scores4,1)
l4 = m4 - prctile(Scores4, 50 - CONF_INTERVAL, 1);
u4 = prctile(Scores4, 50 + CONF_INTERVAL, 1) - m4;

% Compute error bar bounds
e1 = l1; e1(:,:,end+1) = u1;
e2 = l2; e2(:,:,end+1) = u2;
e3 = l3; e3(:,:,end+1) = u3;
e4 = l4; e4(:,:,end+1) = u4;

% errors = lower; errors(:,:,end+1) = upper;
% 
% % If doing medians...
% barHandle = barwitherr(errors, medians);
% pValues = zeros(1, 8);
% for i = 1:7
%     pValues(i) = ranksum(scores(i,:), scores(end,:));
% end

%% Mean analysis
mean1 = mean(Scores1,1);
std1  = std(Scores1,0,1);

mean2 = mean(Scores2,1);
std2 = std(Scores2,0,1);

mean3 = mean(Scores3,1);
std3  = std(Scores3,0,1);

mean4 = mean(Scores4,1);
std4  = std(Scores4,0,1);

% Assemble for plotting

% pValues = zeros(1, k);
% for i = 1:k
%     pValues(i) = ttest2(data1(:, i), data2(:, i));
% end

nS1 = sqrt(numel(Scores1(:,1)));
nS2 = sqrt(numel(Scores2(:,1)));
nS3 = sqrt(numel(Scores3(:,1)));
nS4 = sqrt(numel(Scores4(:,1)));

%% Convert to standard error
%std1 = std1/nS1;
%std2 = std2/nS2;
%std3 = std3/nS3;
%std4 = std4/nS4;

P0G1m = [mean1(1), mean2(1), mean3(1), mean4(1)];
P0G1s = [std1(1), std2(1), std3(1), std4(1)];
P0G1med = [m1(1), m2(1), m3(1), m4(1)];
P0G1pct = [e1(:,1,:), e2(:,1,:), e3(:,1,:), e4(:,1,:)];

P0G1Am = [mean1(2), mean2(2), mean3(2), mean4(2)];
P0G1As = [std1(2), std2(2), std3(2), std4(2)];
P0G1Amed = [m1(2), m2(2), m3(2), m4(2)];
P0G1Apct = [e1(:,2,:), e2(:,2,:), e3(:,2,:), e4(:,2,:)];

P1G1m = [mean1(3), mean2(3), mean3(3), mean4(3)];
P1G1s = [std1(3), std2(3), std3(3), std4(3)];
P1G1med = [m1(3), m2(3), m3(3), m4(3)];
P1G1pct = [e1(:,3,:), e2(:,3,:), e3(:,3,:), e4(:,3,:)];

P1G1Am = [mean1(4), mean2(4), mean3(4), mean4(4)];
P1G1As = [std1(4), std2(4), std3(4), std4(4)];
P1G1Amed = [m1(4), m2(4), m3(4), m4(4)];
P1G1Apct = [e1(:,4,:), e2(:,4,:), e3(:,4,:), e4(:,4,:)];

P1G4m = [mean1(5), mean2(5), mean3(5), mean4(5)];
P1G4s = [std1(5), std2(5), std3(5), std4(5)];
P1G4med = [m1(5), m2(5), m3(5), m4(5)];
P1G4pct = [e1(:,5,:), e2(:,5,:), e3(:,5,:), e4(:,5,:)];

% barwitherr([P0G1s' P0G1As' P1G1s' P1G1As' P1G4s'], [P0G1m' P0G1Am' P1G1m' P1G1Am' P1G4m']);
barwitherr([P0G1s' P1G1s' P1G4s'], [P0G1m' P1G1m' P1G4m']);

% Below for median
err = [P0G1pct(:,:,1)' P1G1pct(:,:,1)' P1G4pct(:,:,1)'];
err(:,:,end+1) = [P0G1pct(:,:,2)' P1G1pct(:,:,2)' P1G4pct(:,:,2)'];
%barwitherr(err, [P0G1med' P1G1med' P1G4med'])

% Compute p values for all versus P1G1 (the baseline)
pValues = zeros(4,5);
for i = 1:5
    [~,pValues(1,i)] = ttest2(Scores1(:,i), Scores1(:,3));
    [~,pValues(2,i)] = ttest2(Scores2(:,i), Scores2(:,3));
    [~,pValues(3,i)] = ttest2(Scores3(:,i), Scores3(:,3));
    [~,pValues(4,i)] = ttest2(Scores4(:,i), Scores4(:,3));
end

% Compute p values for all versus P1G0 (the baseline)
pValuesRankSum = zeros(4,5);
for i = 1:5
    [~,pValuesRankSum(1,i)] = ranksum(Scores1(:,i), Scores1(:,1));
    [~,pValuesRankSum(2,i)] = ranksum(Scores2(:,i), Scores2(:,1));
    [~,pValuesRankSum(3,i)] = ranksum(Scores3(:,i), Scores3(:,1));
    [~,pValuesRankSum(4,i)] = ranksum(Scores4(:,i), Scores4(:,1));
end
saveas(gcf, 'Test.svg')

end

function [shapeScores] = getScores( directory, shapeSize )

    files = dir(strcat(directory, sprintf('4x4_%d*scores.txt', shapeSize)));
    shapeFile = {files(~[files.isdir]).name};

    shapeScores = zeros(size(shapeFile));
    
    for i = 1:size(shapeScores,1)
        for j = 1:size(shapeScores,2)            
            file = char(shapeFile(i,j));
            path = char(fullfile(directory, file));
            D = dlmread(path);
            % A tuple of {score180, averageScore, minScore, maxScore, stddev, median} */
            shapeScores(i,j) = D(1);            
        end
    end    
    shapeScores = shapeScores';
end
