% This script processes the clip-art like images from www.lems.brown.edu/~dmc

% /data/datasets/binary/www.lems.brown.edu/~dmc/LinktoImages/1k

input_folder = '/data/datasets/binary/www.lems.brown.edu/~dmc/LinktoImages/1k';
output_folder = '/data/datasets/binary/processed/1k';
% Older params: radius 6, minsize 40 40
radius = 6;
minSize = [40 40];

scale = 10; % amount to scale up minSized images

files = dir(strcat(input_folder, '/*.tif'));
for file = files'
    img = double(imread(strcat(input_folder, '/', file.name)));
    img = resizeImageToBoundary( img, radius, minSize );
    img = imresize(img, scale, 'lanczos2');
    
    [~, name, ~] = fileparts(file.name);
    
    out_name = strcat(output_folder, '/', name, '.png');
    imwrite(img, out_name);
end