function [ output ] = reformatScoresStruct( input )
%reformatScoresStruct Reorganizes scores struct fields

fields = fieldnames(input);
output = struct([]);

for i = 1:numel(fields)
    if ~isempty(strfind(fields{i}, 'hebbian'))
        output(i).type = 'hebbian';
    else
        output(i).type = 'standard';
    end
        
    if ~isempty(strfind(fields{i}, 'noise'))
        startIdx = strfind(fields{i}, 'edge_noise_') + numel('edge_noise_');
    else
        startIdx = strfind(fields{i}, 'edge_') + numel('edge_');
    end
    
    % extract bias
    endIdx = strfind(fields{i}, '_cereal') - 1;
    biasStr = fields{i}(startIdx:endIdx);
    biasStr = strrep(biasStr, '_', '.');
    biasStr = strrep(biasStr, 'N', '-');
    output(i).bias = str2double(biasStr);
    
    output(i).data = input.(char(fields(i)));
end

