function [  ] = visualize( scores )
%visualize Makes da pretty pictures

    makeSubPlots( scores, 'hebbian', 'totals');
    makeSubPlots( scores, 'hebbian', 'colorized');

    makeSubPlots( scores, 'standard', 'totals');
    makeSubPlots( scores, 'standard', 'colorized');

end

function makeSubPlots( scores, type, field )
    figure;
    fields = fieldnames(scores);

    % Get all fields of requested type
    filter = zeros(size(fields));
    for i=1:numel(fields)
        filter(i) = ~isempty(strfind(fields{i}, type));
    end

    subfields = fields(logical(filter));

    for i=1:numel(subfields)
        subplot(3,4,i)
        data = scores.(char(subfields(i))).(field);
        if size(data, 3) > 1
           imshow(normalizeRGB(data)); 
           title(type);
        else
            plot(data);
            title(type);
        end
    end
end
