#ifndef GROUPINGNEURON_H_
#define GROUPINGNEURON_H_

#include "Neuron.H"

namespace bd
{
  //! Neuron that "groups" together border ownership neurons
  class GroupingNeuron : public Neuron
  {
    public:
      using Neuron::Neuron; // inherit ctors

      template <class Archive>
      void serialize( Archive & ar )
      {
        ar( cereal::base_class<Neuron>( this ) );
      }

    protected:
      virtual double updateImpl( SystemState const & state ) override;

      virtual void learnImpl( SystemState const & state, double currentActivation ) override;
  };
}

#endif //GROUPINGNEURON_H_
