#ifndef INHIBITORYINTERNEURON_H_
#define INHIBITORYINTERNEURON_H_

#include "Neuron.H"

namespace bd
{
  //! Neuron that inhibits everything around it
  /*! This neuron should really exist in the same layer as the neurons
      that it inhibits but it is easier to separate into its own sheet,
      so we'll use feedforward and feedback instead of pure lateral connections */
  class InhibitoryInterNeuron : public Neuron
  {
    public:
      InhibitoryInterNeuron();

      InhibitoryInterNeuron( std::pair<double, double> pos );

      template <class Archive>
      void serialize( Archive & ar )
      {
        ar( cereal::base_class<Neuron>( this ) );
      }

    protected:
      virtual double updateImpl( SystemState const & state ) override;

      virtual void learnImpl( SystemState const & state, double currentActivation ) override;
  };
}

#endif //INHIBITORYINTERNEURON_H_
