#ifndef RANDOM_H_
#define RANDOM_H_

#include <functional>
#include <limits>

namespace bd
{
  // Generate a random number in the range [lower, upper]
  template <class T>
  auto uniformInt( T lower, T upper ) -> std::function<T()>;

  // Generate a random number in the range [lower, upper)
  template <class T>
  auto uniformReal( T lower, T upper ) -> std::function<T()>;

  // Gaussian random number
  auto normalReal( double mean = 0.0, double variance = 1.0 ) -> std::function<double()>;

  // Generate a guassian number within a certain range [lower, upper]
  auto boundedNormalReal( double mean = 0.0, double std = 1.0,
                          double lower = -std::numeric_limits<double>::max(),
                          double upper =  std::numeric_limits<double>::max() ) -> std::function<double()>;
};

#include "RandomImpl.H"

#endif // RANDOM_H_
