#ifndef STATICNEURON_H_
#define STATICNEURON_H_

#include "Neuron.H"
#include <cereal/types/base_class.hpp>

namespace bd
{
  //! A neuron whose activation never changes
  class StaticNeuron : public Neuron
  {
    public:
      StaticNeuron() = default;

      StaticNeuron( std::pair<double, double> pos );

      using Neuron::setActivation;

      template <class Archive>
      void serialize( Archive & ar )
      {
        ar( cereal::base_class<Neuron>( this ) );
      }

    protected:
      double updateImpl( SystemState const & state ) override;

      void learnImpl( SystemState const & state, double currentActivation ) override;
  };
}

#endif // STATICNEURON_H_
